---
title: CanvasRenderingContext2D.setTransform()
slug: Web/API/CanvasRenderingContext2D/setTransform
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.setTransform()</code></strong> method of the Canvas 2D API resets (overrides) the current transformation to the identity matrix, and then invokes a transformation described by the arguments of this method. This lets you scale, rotate, translate (move), and skew the context.</p>

<div class="notecard note">
<p><strong>Note:</strong> See also the {{domxref("CanvasRenderingContext2D.transform()", "transform()")}} method; instead of overriding the current transform matrix, it multiplies it with a given one.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.setTransform(<em>a</em>, <em>b</em>, <em>c</em>, <em>d</em>, <em>e</em>, <em>f</em>);
ctx.setTransform(<em>matrix</em>);
</pre>

<p>The transformation matrix is described by: <math><semantics><mrow><mo>[</mo><mtable columnalign="center center center" rowspacing="0.5ex"><mtr><mtd><mi>a</mi></mtd><mtd><mi>c</mi></mtd><mtd><mi>e</mi></mtd></mtr><mtr><mtd><mi>b</mi></mtd><mtd><mi>d</mi></mtd><mtd><mi>f</mi></mtd></mtr><mtr><mtd><mn>0</mn></mtd><mtd><mn>0</mn></mtd><mtd><mn>1</mn></mtd></mtr></mtable><mo>]</mo></mrow><annotation encoding="TeX">\left[ \begin{array}{ccc} a &amp; c &amp; e \\ b &amp; d &amp; f \\ 0 &amp; 0 &amp; 1 \end{array} \right]</annotation></semantics></math></p>

<h3 id="Parameters">Parameters</h3>

<p><code>setTransform()</code> has two types of parameter that it can accept. The older type consists of several parameters representing the individual components of the transformation matrix to set:</p>

<dl>
 <dt><code>a</code> (<code>m11</code>)</dt>
 <dd>Horizontal scaling. A value of <code>1</code> results in no scaling.</dd>
 <dt><code>b</code> (<code>m12</code>)</dt>
 <dd>Vertical skewing.</dd>
 <dt><code>c</code> (<code>m21</code>)</dt>
 <dd>Horizontal skewing.</dd>
 <dt><code>d</code> (<code>m22</code>)</dt>
 <dd>Vertical scaling. A value of <code>1</code> results in no scaling.</dd>
 <dt><code>e</code> (<code>dx</code>)</dt>
 <dd>Horizontal translation (moving).</dd>
 <dt><code>f</code> (<code>dy</code>)</dt>
 <dd>Vertical translation (moving).</dd>
</dl>

<p>The newer type consists of a single parameter, <code>matrix</code>, representing a 2D transformation matrix to set (technically, a <code>DOMMatrixInit</code> object; any object will do as long as it contains the above components as properties).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Skewing_a_shape">Skewing a shape</h3>

<p>This example skews a rectangle both vertically (<code>.2</code>) and horizontally (<code>.8</code>). Scaling and translation remain unchanged.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.setTransform(1, .2, .8, 1, 0, 0);
ctx.fillRect(0, 0, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Skewing_a_shape', 700, 180) }}</p>

<h3 id="Retrieving_and_passing_a_DOMMatrix_object">Retrieving and passing a DOMMatrix object</h3>

<p>In the following example, we have two {{htmlelement("canvas")}} elements. We apply a transform to the first one's context using the first type of <code>setTransform()</code> and draw a square on it, then retrieve the matrix from it using {{domxref("CanvasRenderingContext2D.getTransform()")}}.</p>

<p>We then apply the retrieved matrix directly to the second canvas context by passing the <code>DOMMatrix</code> object directly to <code>setTransform()</code> (i.e. the second type), and draw a circle on it.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas width="240"&gt;&lt;/canvas&gt;
&lt;canvas width="240"&gt;&lt;/canvas&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">canvas {
  border: 1px solid black;
}</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js">const canvases = document.querySelectorAll('canvas');
const ctx1 = canvases[0].getContext('2d');
const ctx2 = canvases[1].getContext('2d');

ctx1.setTransform(1, .2, .8, 1, 0, 0);
ctx1.fillRect(25, 25, 50, 50);

let storedTransform = ctx1.getTransform();
console.log(storedTransform);

ctx2.setTransform(storedTransform);
ctx2.beginPath();
ctx2.arc(50, 50, 50, 0, 2 * Math.PI);
ctx2.fill();</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Retrieving_and_passing_a_DOMMatrix_object', "100%", 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-settransform", "CanvasRenderingContext2D.setTransform")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.setTransform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.transform()")}}</li>
</ul>
